'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* global __webpack_public_path__, window */
/* eslint no-console: 0 */

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _stripAnsi = require('strip-ansi');

var _stripAnsi2 = _interopRequireDefault(_stripAnsi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function location() {
  /* eslint camelcase: 0 */
  var base = __webpack_public_path__ + '/socket.io';
  var parts = _url2.default.parse(base);

  if (base.charAt(0) === '/') {
    return _extends({}, parts, {
      auth: window.location.auth,
      hostname: window.location.hostname,
      host: window.location.host,
      port: window.location.port,
      protocol: window.location.protocol
    });
  }
  return parts;
}

var parts = location();
console.log('GOT PARTS', parts);
var io = _socket2.default.connect(parts.host, { path: parts.path });

var hot = false;
var initial = true;
var currentHash = '';

io.on('hot', function () {
  hot = true;
  console.log('[WDS] Hot Module Replacement enabled.');
});

io.on('invalid', function () {
  console.log('[WDS] App updated. Recompiling...');
});

io.on('hash', function (hash) {
  currentHash = hash;
});

io.on('still-ok', function () {
  console.log('[WDS] Nothing changed.');
});

io.on('ok', function () {
  if (initial) {
    initial = false;
    return;
  }
  reloadApp();
});

io.on('warnings', function (warnings) {
  console.log('[WDS] Warnings while compiling.');
  for (var i = 0; i < warnings.length; i++) {
    console.warn((0, _stripAnsi2.default)(warnings[i]));
  }
  if (initial) {
    initial = false;
    return;
  }
  reloadApp();
});

io.on('errors', function (errors) {
  console.log('[WDS] Errors while compiling.');
  for (var i = 0; i < errors.length; i++) {
    console.error((0, _stripAnsi2.default)(errors[i]));
  }
  if (initial) {
    initial = false;
    return;
  }
  reloadApp();
});

io.on('proxy-error', function (errors) {
  console.log('[WDS] Proxy error.');
  for (var i = 0; i < errors.length; i++) {
    console.error((0, _stripAnsi2.default)(errors[i]));
  }
  if (initial) {
    initial = false;
    return;
  }
  reloadApp();
});

io.on('disconnect', function () {
  console.error('[WDS] Disconnected!');
});

function reloadApp() {
  if (hot) {
    console.log('[WDS] App hot update...');
    window.postMessage('webpackHotUpdate' + currentHash, '*');
  } else {
    console.log('[WDS] App updated. Reloading...');
    window.location.reload();
  }
}
//# sourceMappingURL=dev-client.js.map